SystemOrganization addCategory: #DijEvolution!
SystemOrganization addCategory: #'DijEvolution-Example'!

Object subclass: #DijEvolution
	instanceVariableNames: 'ancestors pool birthExpression'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DijEvolution'!

!DijEvolution methodsFor: 'as yet unclassified' stamp: 'hjo 6/27/2012 04:05'!
initialize

	super initialize.
	pool := OrderedCollection new.
	ancestors := OrderedCollection new. "should be Set?"! !

!DijEvolution methodsFor: 'accessing' stamp: 'hjo 6/27/2012 04:13'!
pool: anOrderedCollection 

	pool := anOrderedCollection! !

!DijEvolution methodsFor: 'as yet unclassified' stamp: 'hjo 6/27/2012 04:27'!
step

	| each born |
	birthExpression := [:obj| obj variations ].
	each := pool first.
	born := birthExpression value: each.
	born halt.! !

Object subclass: #DijLife
	instanceVariableNames: 'birthExpressions cost'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DijEvolution'!

!DijLife methodsFor: 'accessing' stamp: 'hjo 6/27/2012 04:27'!
birthExpression: aBlockClosure 

	birthExpressions := Array with: aBlockClosure.! !

!DijLife methodsFor: 'accessing' stamp: 'hjo 6/27/2012 04:08'!
birthExpressions
	^ birthExpressions! !

!DijLife methodsFor: 'accessing' stamp: 'hjo 6/27/2012 04:08'!
birthExpressions: aCollection
	birthExpressions := aCollection
! !

!DijLife methodsFor: 'accessing' stamp: 'hjo 6/27/2012 04:08'!
cost
	^ cost! !

!DijLife methodsFor: 'accessing' stamp: 'hjo 6/27/2012 04:08'!
cost: aNumber
	cost := aNumber
! !

DijLife subclass: #Prime17
	instanceVariableNames: 'integer'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DijEvolution-Example'!

!Prime17 classSide methodsFor: 'as yet unclassified' stamp: 'hjo 6/27/2012 04:12'!
integer: aSmallInteger 

	^self new integer: aSmallInteger.! !

!Prime17 methodsFor: 'as yet unclassified' stamp: 'hjo 6/27/2012 04:12'!
integer: aSmallInteger 

	integer := aSmallInteger.! !

!Prime17 methodsFor: 'as yet unclassified' stamp: 'hjo 6/27/2012 04:29'!
variations

	^#(2 3 4 ) collect: [:m | |born birthExpression|
		birthExpression := [self species integer: (integer * m)\\17].
		born := birthExpression value.
		born birthExpression: birthExpression].
	
	 ! !
